#ifndef COUPMATU_H
#define COUPMATU_H

#include <stdio.h>
#include "alias.h"
#include "aliasc.h"
#include "intpointsc.h"
#include "isotrmatc.h"
#include "sejtkrmatc.h"
#include "baroghelBc.h"
#include "concreteBc.h"
#include "C60baroghelc.h"
#include "C30baroghelc.h"
#include "o30bazantc.h"
#include "C60bazantc.h"
#include "glasgowmatc.h"
#include "glasgowcoup.h"
#include "xfile.h"

class coupmatu
{
 public:
  coupmatu (void);
  ~coupmatu (void);
  void ipalloc (void);
  long intpnum (void);
  void readip (XFILE *in);
  void readmatchar (XFILE *in);
  void intpointalloc ();
  void intpointinit ();
  void read (XFILE *in);
  void matstiff (matrix &d,long ipp);
  void matcond (matrix &d,long ipp,long ri,long ci);
  void matcap (matrix &d,long ipp,long ri,long ci);
  void volume_rhs1 (matrix &d,long ipp,long ri,long ci);
  void volume_rhs2 (matrix &d,long ipp,long ri,long ci,long ncomp);

  void computenlstresses (matrix &d,long ipp);
  void storestresses (long ipp,long fi,vector &gr);
  void givestresses (long ipp,long fi,vector &fl);
  void storestrain (long ipp,long fi,vector &eps);
  void givestrain (long ipp,long fi,vector &eps);
  void storegrad (long lcid,long ipp,long fi,vector &gr);

  //for testing
  void computeigenstresses (matrix &d,long ipp,vector &fl);

  void material_matrix (matrix &d,long eid,long ri,long ci,strastrestate ssst);

  //  number of material types
  long nmt;
  //  total number of all integration points
  long tnip;
  //  pointer to integration points
  intpointsc *ip;

  //  COUPLING PROBLEMS
  //  one-phase medium - heat transfer - isotropic heat-elast material
  isotrmatc *itrmc;
  //  saturate-unsaturated one-phase flow in deforming meduim
  sejtkrmatc *sejtkrmc;
  //three-phase medium
  baroghelmatc *baroghelc;
  concreteBmatc *concretec;
  C60barmatc  *C60baroghelc;
  C30barmatc  *C30baroghelc;
  o30bazmatc  *o30bazantc;
  C60bazmatc  *C60bazantc;
  glasgowmatc *tenchc;
  
  glasgowcoup *gcm;
};

#endif
