#ifndef COUPTOP_H
#define COUPTOP_H

#include <stdio.h>
#include "aliasc.h"
#include "alias.h"
#include "elementc.h"
#include "iotools.h"

class node;
class element;
struct vector;
struct ivector;


/**
   CLASS COUPTOP
   
   it is one of the 5 most important classes of the program

   class couptop contains topology data of problem
   
   basic data
   nn (long number) - stands for number of nodes in problem
   ncn (long) - stands for number of constrained nodes
   ne (long) - stands for number of all finite elements in problem
   
   class mechtop creates
   nn objects of class node
   ne objects of class element
   
   
   JK, TK
*/
class couptop
{
 public:
  couptop (void);
  ~couptop (void);
  void read (XFILE *in);
  long mesh_check(void);
  
  elemtypec give_elem_type (long eid);
  long give_ndofn (long nid);
  long give_ndofe (long eid);
  //long give_nne (long eid);
  //long give_nne_inner (elemtypec te);
  long give_upper_nip (long eid,long ri,long ci);
  long give_lower_nip (long eid,long ri,long ci);
  void give_elemnodes (long eid,ivector &nodes);
  void give_code_numbers (long eid,long *cn);
  void give_node_coord2d (vector &x,vector &y,long eid);
  void give_node_coord2dxz (vector &x,vector &z,long eid);
  void give_node_coord3d (vector &x,vector &y,vector &z,long eid);
  
  long give_mnb (long eid);
  strastrestate give_mssst (long eid,long bi);
  long give_mncomp (long eid);

  //  number of elements
  long ne;

  elementc *elements;

};

#endif
